Attribute VB_Name = "modSubs"
' Take Lent VERSION 1.0 (08/03/2002)
' By Frederico Machado (indiofu@bol.com.br)
' Please vote for me if you like the game
'
' ************************************************** '
' Just some Subs that I wrote all by myself          '
' I've created the Map loader and the map style.     '
' You can use these subs in your own games           '
' but don't forget to give me some credit.           '
' Just send me an e-mail, just to know, you know...  '
' Sorry my English, I'm Brazilian! :)                '
' ************************************************** '
'
' ************************************************** '
' I need some help to add the player and a car to    '
' drive. The movements must to be similar to the     '
' movements of GTA (like character rotation, etc)    '
' Anyway, thanks to read it!                         '
' ************************************************** '

Option Explicit

Global TexturePath As String ' Our texture directory
Global MeshPath As String ' Our mesh directory
Global ObjectPath As String

Public Const W_FRONT = 0 ' Means wall in the front
Public Const W_BACK = 1  ' Means wall in the back
Public Const W_LEFT = 2  ' wall in the left
Public Const W_RIGHT = 3 ' wall in the right

' Adds a wall in any point in the scene
' W = wall, where it will be placed. You can use the consts W_FRONT, W_BACK, ...
' SX means the Size in the X coord
' SY means the Size in the Y coord, easy...
' X = position in the X coord where it will be placed
' Y = position in the Y coord where it will be placed
' Z = position in the Z coord where it will be placed
' Texture = just the filename of the texture
' FU means how many times the texture will be tiled in the X coord
' FV means how many times the texture will be tiled in the Y coord
Public Sub AddWall(W As Integer, SX As Single, SY As Single, X As Single, Y As Single, Z As Single, Texture As String, FU As Single, FV As Single)
  
  Dim WallFace As Direct3DRMFace2 ' Just the Wall Face
  Dim WallTexture As Direct3DRMTexture3 ' It will contain the texture of the wall
  Dim MS_Wall As Direct3DRMMeshBuilder3 ' It will contain the wall
  
  Set MS_Wall = D3D_Main.CreateMeshBuilder() ' Lets create the meshbuilder
  Set WallTexture = D3D_Main.LoadTexture(Texture) ' Loads the texture
  
  Set WallFace = D3D_Main.CreateFace ' Lets create the face
  
  If W = W_FRONT Then
    WallFace.AddVertex X, Y, Z: WallFace.AddVertex X, Y + SY, Z: WallFace.AddVertex X + SX, Y + SY, Z: WallFace.AddVertex X + SX, Y, Z ' We create the front of the wall
    WallFace.AddVertex X + SX, Y, Z: WallFace.AddVertex X + SX, Y + SY, Z: WallFace.AddVertex X, Y + SY, Z: WallFace.AddVertex X, Y, Z ' and the back of the wall
  ElseIf W = W_BACK Then
    WallFace.AddVertex X + SX, Y, Z: WallFace.AddVertex X + SX, Y + SY, Z: WallFace.AddVertex X, Y + SY, Z: WallFace.AddVertex X, Y, Z ' We create the front of the wall
    WallFace.AddVertex X, Y, Z: WallFace.AddVertex X, Y + SY, Z: WallFace.AddVertex X + SX, Y + SY, Z: WallFace.AddVertex X + SX, Y, Z ' and the back of the wall
  ElseIf W = W_LEFT Then
    WallFace.AddVertex X, Y, Z: WallFace.AddVertex X, Y + SY, Z: WallFace.AddVertex X, Y + SY, Z + SX: WallFace.AddVertex X, Y, Z + SX ' We create the front of the wall
    WallFace.AddVertex X, Y, Z + SX: WallFace.AddVertex X, Y + SY, Z + SX: WallFace.AddVertex X, Y + SY, Z: WallFace.AddVertex X, Y, Z ' and the back of the wall
  ElseIf W = W_RIGHT Then
    WallFace.AddVertex X, Y, Z + SX: WallFace.AddVertex X, Y + SY, Z + SX: WallFace.AddVertex X, Y + SY, Z: WallFace.AddVertex X, Y, Z ' We create the front of the wall
    WallFace.AddVertex X, Y, Z: WallFace.AddVertex X, Y + SY, Z: WallFace.AddVertex X, Y + SY, Z + SX: WallFace.AddVertex X, Y, Z + SX ' and the back of the wall
  Else
    Exit Sub ' this type of wall doesn't exist for us
  End If
  
  MS_Wall.AddFace WallFace ' Add the face to the meshbuilder
  
  MS_Wall.SetTextureCoordinates 0, 0, FV ' set the texture coordinates in the front of the wall
  MS_Wall.SetTextureCoordinates 1, 0, 0
  MS_Wall.SetTextureCoordinates 2, FU, 0
  MS_Wall.SetTextureCoordinates 3, FU, FV
  MS_Wall.SetTextureCoordinates 4, FU, FV ' set the texture coordinates in the back of the wall
  MS_Wall.SetTextureCoordinates 5, FU, 0
  MS_Wall.SetTextureCoordinates 6, 0, 0
  MS_Wall.SetTextureCoordinates 7, 0, FV
  
  MS_Wall.SetPerspective 1 ' Set the perspective
  
  Set WallFace = MS_Wall.GetFace(0) ' Get the face
  WallFace.SetTexture WallTexture ' set the texture

  FR_Building.AddVisual MS_Wall ' Add to its frame

End Sub

' Adds a floor in any point in the scene
' SX means the Size in the X coord
' SY means the Size in the Y coord, easy...
' X = position in the X coord where it will be placed
' Y = position in the Y coord where it will be placed
' Z = position in the Z coord where it will be placed
' Texture = just the filename of the texture
' FU means how many times the texture will be tiled in the X coord
' FV means how many times the texture will be tiled in the Y coord
Public Sub AddFloor(SX As Single, SY As Single, X As Single, Y As Single, Z As Single, Texture As String, FU As Single, FV As Single)

  Dim FloorFace As Direct3DRMFace2 ' The floor face
  Dim FloorTexture As Direct3DRMTexture3 ' It will contain the texture of the wall
  Dim MS_Floor As Direct3DRMMeshBuilder3 ' Will contain the floor
  
  Set MS_Floor = D3D_Main.CreateMeshBuilder() ' Create our meshbuilder
  Set FloorTexture = D3D_Main.LoadTexture(Texture) ' Load our texture
  
  Set FloorFace = D3D_Main.CreateFace ' Lets create our face
  
  FloorFace.AddVertex X, Y, Z: FloorFace.AddVertex X, Y, Z + SY: FloorFace.AddVertex X + SX, Y, Z + SY: FloorFace.AddVertex X + SX, Y, Z ' Create the floor
  
  MS_Floor.AddFace FloorFace ' Add the floor face
  
  MS_Floor.SetTextureCoordinates 0, 0, FV ' Lets set the texture coordinates
  MS_Floor.SetTextureCoordinates 1, 0, 0
  MS_Floor.SetTextureCoordinates 2, FU, 0
  MS_Floor.SetTextureCoordinates 3, FU, FV
  
  MS_Floor.SetPerspective 1 ' Set the perspective
  
  Set FloorFace = MS_Floor.GetFace(0) ' Get the face
  FloorFace.SetTexture FloorTexture ' Set the texture

  FR_Building.AddVisual MS_Floor ' Add the floor to its frame

End Sub

' Adds a floor in any point in the scene
' SX means the Size in the X coord
' SY means the Size in the Y coord, easy...
' X = position in the X coord where it will be placed
' Y = position in the Y coord where it will be placed
' Z = position in the Z coord where it will be placed
' Texture = just the filename of the texture
' FU means how many times the texture will be tiled in the X coord
' FV means how many times the texture will be tiled in the Y coord
Public Sub AddRoof(SX As Single, SY As Single, X As Single, Y As Single, Z As Single, Texture As String, FU As Single, FV As Single)

  Dim RoofFace As Direct3DRMFace2 ' The Roof face
  Dim RoofTexture As Direct3DRMTexture3 ' Will contain the texture
  Dim MS_Roof As Direct3DRMMeshBuilder3 ' The roof meshbuilder
  
  Set MS_Roof = D3D_Main.CreateMeshBuilder() ' Create our meshbuilder
  Set RoofTexture = D3D_Main.LoadTexture(Texture) 'Load the roof texture
  
  Set RoofFace = D3D_Main.CreateFace ' Create the roof face
  
  RoofFace.AddVertex X + SX, Y, Z: RoofFace.AddVertex X + SX, Y, Z + SY: RoofFace.AddVertex X, Y, Z + SY: RoofFace.AddVertex X, Y, Z ' Create the roof
  
  MS_Roof.AddFace RoofFace ' Add the face
  
  MS_Roof.SetTextureCoordinates 0, 0, FV ' Lets set the texture coordinates
  MS_Roof.SetTextureCoordinates 1, 0, 0
  MS_Roof.SetTextureCoordinates 2, FU, 0
  MS_Roof.SetTextureCoordinates 3, FU, FV
  
  MS_Roof.SetPerspective 1 ' Set the perspective
  
  Set RoofFace = MS_Roof.GetFace(0) ' Get the face
  RoofFace.SetTexture RoofTexture ' Set the texture

  FR_Building.AddVisual MS_Roof ' Add the roof to its frame

End Sub

' Adds a light to any point in the scene
' X = the X coord where it will be placed
' Y = the Y coord where it will be placed
' Z = the Z coord where it will be placed
' LType = the Light Type. 0 = ambient 1 = point 2 = spot 3 = directional
' vred, vgreen and vblue means the RGB color of the light
' NOTE: the color of the light must to be in decimal, not the default 255
Public Sub AddLight(X As Single, Y As Single, Z As Single, Ltype As CONST_D3DRMLIGHTTYPE, vred As Single, vgreen As Single, vblue As Single)

  Dim FR_NewLight As Direct3DRMFrame3 ' The light frame
  Dim LT_Light As Direct3DRMLight ' Light
  
  Set FR_NewLight = D3D_Main.CreateFrame(FR_Root) ' Create the frame under the FR_Roof in the "tree"
  
  Set LT_Light = D3D_Main.CreateLightRGB(Ltype, vred, vgreen, vblue) ' Create the light and set its color
  'LT_Light.SetLinearAttenuation 0
  'LT_Light.SetQuadraticAttenuation 0
  'LT_Light.SetPenumbra 0
  'LT_Light.SetRange 0
  'LT_Light.SetUmbra 0.1
  
  'FR_NewLight.SetPosition Nothing, X, Y, Z ' Set the position of the light
  FR_NewLight.SetOrientation Nothing, X, Y, Z, 0, 0, 0
  FR_NewLight.AddLight LT_Light ' Add light to its frame

End Sub

' Adds a File .X to any position in the scene
' XFile = filename of the mesh
' Scale = the scale of the mesh
' X = the X coord where it will be placed
' Y = the Y coord where it will be placed
' Z = the Z coord where it will be placed
Public Sub AddMesh(XFile As String, MeshScale As Single, X As Single, Y As Single, Z As Single)

  Dim FR_Mesh As Direct3DRMFrame3 ' The Mesh frame
  Dim MS_Mesh As Direct3DRMMeshBuilder3 ' The MeshBuilder
  
  Set FR_Mesh = D3D_Main.CreateFrame(FR_Root) ' Lets create the frame (under the FR_Root in the "tree")
  Set MS_Mesh = D3D_Main.CreateMeshBuilder() ' Lets create our meshbuilder
  
  MS_Mesh.LoadFromFile XFile, 0, 0, Nothing, Nothing ' Load the file .X
  MS_Mesh.ScaleMesh MeshScale, MeshScale, MeshScale ' Set the scale
  
  FR_Mesh.SetPosition Nothing, X, Y, Z ' Set the position
  FR_Mesh.AddVisual MS_Mesh ' Add the mesh to its frame

End Sub

' It loads the map
' I think it's a good and fast way to load a map
' This loader has a good Error Handling, if something
' is wrong in the map file it appears an error msg
' where you can see the line of the error. :)
Public Sub LoadMap(MapFile As String)
  
  Dim LineNum As Integer
  Dim What As String
  Dim W As Integer
  Dim SX As Single
  Dim SY As Single
  Dim X As Single
  Dim Y As Single
  Dim Z As Single
  Dim Ltype As CONST_D3DRMLIGHTTYPE
  Dim vred As Single
  Dim vgreen As Single
  Dim vblue As Single
  Dim FU As Single
  Dim FV As Single
  Dim XFile As String
  Dim ObjFile As String
  Dim Texture As String
  
  On Error GoTo MapError
  
  Open MapFile For Input As #1 ' Open the map file
    
    Do
      
      LineNum = LineNum + 1
      Input #1, What ' What kind of object
      If Left$(What, 1) = ";" Or What = "" Then GoTo Jump ' If the first char is a ; then it is a comment
      
      LineNum = LineNum + 1
      Select Case UCase(What)
        Case "FLOOR" ' Add a floor
          Input #1, SX, SY, X, Y, Z, Texture, FU, FV
          AddFloor SX, SY, X, Y, Z, TexturePath & Texture, FU, FV
        Case "WALL" ' Add a wall
          Input #1, W, SX, SY, X, Y, Z, Texture, FU, FV
          AddWall W, SX, SY, X, Y, Z, TexturePath & Texture, FU, FV
        Case "ROOF" ' Add a roof
          Input #1, SX, SY, X, Y, Z, Texture, FU, FV
          AddRoof SX, SY, X, Y, Z, TexturePath & Texture, FU, FV
        Case "LIGHT" ' Add a light
          Input #1, X, Y, Z, Ltype, vred, vgreen, vblue
          AddLight X, Y, Z, Ltype, vred, vgreen, vblue
        Case "MESH" ' Add a mesh file
          Input #1, XFile, SY, X, Y, Z
          AddMesh MeshPath & XFile, SY, X, Y, Z
        Case "OBJECT"
          Input #1, ObjFile, X, Z
          AddObject ObjectPath & ObjFile, X, Z
      End Select
      
Jump:
      
    Loop Until EOF(1) ' Loop until end of file
  
  Close #1 ' Close the map file
  
  Exit Sub
  
MapError:
  
  ' Lets restore the display mode to show the msgbox
  DD_Main.RestoreDisplayMode
  DD_Main.SetCooperativeLevel frmMain.hWnd, DDSCL_NORMAL
  DI_Device.Unacquire

  ' Shows the error msg and the line of the error
  MsgBox "Error: There's something wrong in the map file." & vbCrLf & _
    "Filename: " & MapFile & vbCrLf & "Line: " & LineNum, vbCritical, "Error"
  Unload frmMain
  
End Sub

' It adds an object to the surface
' strObject = the object file, where contains the walls, floors, etc (like a map)
' OX = the X location of the object
' 0Z = the Z location of the object
' IMPORTANT: make your object with all X and Z = 0
' because the trully X and Z are added to OX and OZ
' to put the object in the right position.
' Got it????
Public Sub AddObject(strObject As String, OX As Single, OZ As Single)
  
  Dim LineNum As Integer
  Dim What As String
  Dim W As Integer
  Dim SX As Single
  Dim SY As Single
  Dim X As Single
  Dim Y As Single
  Dim Z As Single
  Dim Ltype As CONST_D3DRMLIGHTTYPE
  Dim vred As Single
  Dim vgreen As Single
  Dim vblue As Single
  Dim FU As Single
  Dim FV As Single
  Dim XFile As String
  Dim Texture As String
  
  On Error GoTo MapError
  
  Open strObject For Input As #2 ' Open the map file
    
    Do
      
      LineNum = LineNum + 1
      Input #2, What ' What kind of object
      If Left$(What, 1) = ";" Or What = "" Then GoTo Jump ' If the first char is a ; then it is a comment
      
      LineNum = LineNum + 1
      Select Case UCase(What)
        Case "FLOOR" ' Add a floor
          Input #2, SX, SY, X, Y, Z, Texture, FU, FV
          X = X + OX: Z = Z + OZ
          AddFloor SX, SY, X, Y, Z, TexturePath & Texture, FU, FV
        Case "WALL" ' Add a wall
          Input #2, W, SX, SY, X, Y, Z, Texture, FU, FV
          X = X + OX: Z = Z + OZ
          AddWall W, SX, SY, X, Y, Z, TexturePath & Texture, FU, FV
        Case "ROOF" ' Add a roof
          Input #2, SX, SY, X, Y, Z, Texture, FU, FV
          X = X + OX: Z = Z + OZ
          AddRoof SX, SY, X, Y, Z, TexturePath & Texture, FU, FV
        Case "LIGHT" ' Add a light
          Input #2, X, Y, Z, Ltype, vred, vgreen, vblue
          X = X + OX: Z = Z + OZ
          AddLight X, Y, Z, Ltype, vred, vgreen, vblue
        Case "MESH" ' Add a mesh file
          Input #2, XFile, SY, X, Y, Z
          X = X + OX: Z = Z + OZ
          AddMesh MeshPath & XFile, SY, X, Y, Z
      End Select
      
Jump:
      
    Loop Until EOF(2) ' Loop until end of file
  
  Close #2 ' Close the map file
  
  Exit Sub
  
MapError:
  
  ' Lets restore the display mode to show the msgbox
  DD_Main.RestoreDisplayMode
  DD_Main.SetCooperativeLevel frmMain.hWnd, DDSCL_NORMAL
  DI_Device.Unacquire

  ' Shows the error msg and the line of the error
  MsgBox "Error: There's something wrong in the object file." & vbCrLf & _
    "Filename: " & strObject & vbCrLf & "Line: " & LineNum, vbCritical, "Error"
  Unload frmMain
  
End Sub

